indexing
	description: "A cell holds an item and a reference to the first cell in a list of cells."

class IMMUTABLE_CELL [G]

create
	make

feature -- queries

	item: G
	right: IMMUTABLE_CELL[G]

feature -- creation

	make ( an_item:G; a_cell: IMMUTABLE_CELL [G] ) is
			-- Make a new cell
		do
			item := an_item
			right := a_cell
		ensure
			item_set: item = an_item
			right_set: right = a_cell
		end

feature {IMMUTABLE_LIST } -- support for creating lists of cells

	set_right( a_cell : IMMUTABLE_CELL[ G ] ) is
			-- Set 'Current' to point to 'a_cell' (which can be Void)
		do
			right := a_cell
		ensure
			right_set: right = a_cell
		end
end
