indexing
	description: "Simple list of names (relaxed preconditions on put and remove)";

class
	RELAXED_NAME_LIST
inherit
	NAME_LIST
redefine
	put, remove
end


creation 
	make 

feature -- commands

	put(a_name : STRING ) is 
			-- Add name to list
		require else 
			name_in_list: has( a_name ) 
		do 	
			if
				not has( a_name )
			then
				count:=count + 1
				contents.put( a_name, count ) 
			end
		ensure then
			count_unchanged_if_name_was_already_in_list: (old has( a_name )) implies count = old count
		end  


	remove( a_name : STRING ) is
			-- Remove name from list
		require else
			name_not_in_list: not has( a_name ) 
		do 
			if
				has( a_name )
			then
				contents.put(contents.item(count), position_of( a_name ))
				count:=count -1
			end
		ensure then
			count_unchanged_if_name_was_not_in_list: ( not old has( a_name ) ) implies count = old count
		end

end