indexing
	description: 
		" Objects of subclasses of ABSTRACT_OBSERVER register with objects %
		% of subclasses of ABSTRACT_SUBJECT if they want to be notified %
		% that their subject has changed."

deferred class ABSTRACT_OBSERVER

inherit
	BUG_SWITCHES
		-- To make it easier to switch bugs on and off, to see what
		-- the contracts catch.

feature
	up_to_date_with_subject : BOOLEAN is
			-- True if the observer correctly reflects 
			-- the subject, false otherwise.
			--
			-- To be redefined in subclasses. (The routine
			-- is effective rather than deferred so that
			-- it returns 'false' by default. If a subclass
			-- fails to redefine this routine, the problem
			-- will be caught.)
		do
		end

	update is
			-- If this observer has attached itself to 
			-- a subject as one of the observers 
			-- of that subject then 'update' is
			-- called whenever the subject calls its 
			-- 'notify' routine.
		deferred
		ensure
			observer_is_up_to_date_with_subject:
				up_to_date_with_subject
		end
end

