indexing
	description: 
		" List of boolean and integer-valued variables that are used %
		% in subclasses as switches to control whether bugs are to %
		% have their effect or are to be skipped. %
		% %
		% When a switch is 'on', the corresponding bug has its effect. %
		% %
		% A boolean-valued switch is 'on' when its value is true. %
		% %
		% An integer-valued switch is 'off' when it is zero. It is %
		% 'on' and, conceptually, gives a value to the 'i' in its %	
		% name when its value is positive. %
		% %
		% Classes inherit BUG_SWITCHES to get access to the switches. %
		% Lines of code that are to do with planting bugs have '---' %
		% after the executable Eiffel, to distinguish them from %
		% normal code. %
		% %
		% Read each switch's name as if it said 'bug: some fault'."

class BUG_SWITCHES

feature {NONE} --  switches for bugs in subjects

	bug__observer_not_attached : BOOLEAN is false

	bug__attach_loses_observer_i : INTEGER is 0

	--bug__attach_adds_a_spurious_observer : BOOLEAN is false	-- code for this bug not implemented yet

	bug__attach_duplicates_an_existing_observer : BOOLEAN is false

		--(When 'attach' duplicates an existing observer, so that
		--it is attached twice, this bug is not detected because the
		--duplicated observer ends up being updated twice, and in this
		--version we don't check for that.)

	bug__subject_fails_to_respond_to_notify : BOOLEAN is false

	bug__subject_fails_to_inform_observer_i : INTEGER is 0

feature {NONE} --  switches for bugs in observers 

	bug__concrete_observer_fails_to_redefine_is_consistent_with_subject : BOOLEAN is false

end -- class BUG_SWITCHES
