indexing
	description: 
		" An object of class CONCRETE_OBSERVER_5 tries to look at %
		% its subjects set of observers. "

class CONCRETE_OBSERVER_5


inherit
	ABSTRACT_OBSERVER
		redefine
			up_to_date_with_subject
		end

create
	initialize


feature -- basic queries

	my_concrete_subject : CONCRETE_SUBJECT
	my_state : INTEGER

feature -- initialization

	initialize( a_concrete_subject : CONCRETE_SUBJECT ) is
		do
			my_concrete_subject := a_concrete_subject
			my_concrete_subject.attach( Current )
			
			all_observers := a_concrete_subject.observers
					-- This statement tries to peek at all the observers.
		ensure
			my_concrete_subject_is_given_one:
				my_concrete_subject = a_concrete_subject
			attached_to_given_subject:
				my_concrete_subject.attached( Current )
		end

feature -- updating

	up_to_date_with_subject : BOOLEAN is
			-- Is this observer up-to-date with respect
			-- to the subject it is attached to?
		do
			Result := my_concrete_subject.concrete_state = my_state
		ensure then
			result_is_my_state_equals_subject_state:
				Result = ( my_state = my_concrete_subject.concrete_state )
		end

	update is
			-- Bring Current up to date with the
			-- subject it is attached to.
		do
			my_state := my_concrete_subject.concrete_state
		end

end -- class CONCRETE_OBSERVER_5
