deferred class SUBJECT_TYPE_WITH_FRAMING

		-- Add framing rules to the 'attach', 'detach'
		-- and 'notify' methods of SUBJECT_TYPE

inherit
	SUBJECT_TYPE

feature -- attach and detach observers

	attach( o : ABSTRACT_OBSERVER ) is
		deferred
		ensure then
			no_other_changes:
				old ( ( o /= Void) and (not attached(o)) ) implies
					observers.minus( o ).is_equal( old ( observers ) )
		end

	detach( o : ABSTRACT_OBSERVER ) is
		deferred
		ensure then
			no_other_changes:
				old ( ( o /= Void) and attached(o) ) implies
					observers.plus( o ).is_equal( old ( observers ) )
		end

feature -- send notifications

	notify is
		deferred
		ensure then
			unchanged_set_of_observers:	-- a placeholder for a more complex frame rule when re-entrancy control is added
					observers.is_equal( old ( clone( observers ) ) )
		end


end -- class SUBJECT_TYPE_WITH_FRAMING

