indexing
	description:
		" Basic test of the observer framework's contracts %
		% %
		% Create a concrete subject and some concrete %
		% observers, and call 'run' on the concrete subject. %
		% %
		% The concrete subject repeatedly increments %
		% an integer, and calls notify on itself. %
		% %
		% Each concrete observer maintains a concrete state %
		% that is the subject state multiplied by i (the %
		% concrete observer classes have names of the form %
		% CONCRETE_OBSERVER_i). %
		% %
		% Each time a concrete observer is updated, it puts %
		% its current state onto the standard output, preceded %
		% by its number. "



class TEST_BASICS

create
	initialize

feature {NONE} -- concrete subject and observer objects

	s : CONCRETE_SUBJECT
	o1 : CONCRETE_OBSERVER_1
	o2 : CONCRETE_OBSERVER_2
	o3 : CONCRETE_OBSERVER_3
	o4 : CONCRETE_OBSERVER_4

feature {NONE} -- creation

	initialize is
		do
			io.putstring("Starting TEST_BASICS.initialize")	io.new_line	io.new_line

			io.putstring("Each time a concrete observer is updated, it puts")			io.new_line
			io.putstring("its current state onto the standard output, preceded")		io.new_line
			io.putstring("by its number. So, a successful run will produce lines of")	io.new_line
			io.putstring("output of the form:       O1:11  O2:22  O3:33")			io.new_line
																io.new_line	io.new_line
			io.putstring("Here we go ...")								io.new_line	io.new_line

			create s.initialize
			create o1.initialize(s)
			create o2.initialize(s)
			create o3.initialize(s)
			create o4.initialize(s)

			s.run

			io.new_line
			io.new_line
			io.putstring("Done")
			io.new_line
		end

end

