indexing
	description:
		" An increment button has an associated counter. When the the button is clicked, %
		% its 'on_bn_clicked' routine is called back, and the counter is incremented. "


class INCREMENT_BUTTON

inherit
	WEL_PUSH_BUTTON
		rename
			make as base_initialize
		redefine
			on_bn_clicked
		end
create
	initialize

feature {NONE} -- the button's associated counter and its view

	counter : COUNTER

feature -- creation

	initialize(
		a_counter : COUNTER;
		a_parent: WEL_COMPOSITE_WINDOW;
		a_name: STRING;					-- name on button
		an_x, a_y : INTEGER;				-- location of button
		a_width, a_height : INTEGER;			-- size of button
		an_id: INTEGER ) is

			-- Make a button that can increment a counter and show
			-- its new value in the view of that counter
		do
			base_initialize( a_parent, a_name, an_x, a_y, a_width, a_height, an_id )
			counter := a_counter
		end

feature --callback

	on_bn_clicked is
			-- Increment the counter.
		do
			counter.increment
		end

end --class INCREMENT_BUTTON
