/**
 * @invariant size() >= 0
 */
public interface IDictionary {

/***************************
 * Basic queries
 ***************************/

	/**
	 */
	public long size();

	/**
	 * @require key != null
	 * @ensure  (size() == 0) implies !return
	 */
	public boolean has(Object key);

	/**
	 * @require key != null
	 * @require has(key)
	 */
	public Object valueFor(Object key);

/***************************
 * Derived queries
 ***************************/

	/**
	 * @ensure  return == (size() == 0)
	 */
	public boolean isEmpty();

/***************************
 * Commands
 ***************************

	/**
	 * @require key != null
	 * @require !has(key)
	 *
	 * @ensure size() == size()@pre + 1
	 * @ensure has(key)
	 * @ensure valueFor(key) == value
	 */
	public void put(Object key, Object value);

	/**
	 * @require key != null
	 * @require has(key)
	 *
	 * @ensure size() == size()@pre - 1
	 * @ensure !has(key)
 * //@ensure valueFor(key) undefined
 * //(see precondition on valueFor() )
	 */
	public void remove(Object key);
}
