import java.awt.*;

public class TestDictionary {
	
	private static TestDictionary td;

	public static void main(String[] args) {

		td = new TestDictionary();
		td.run();
	

}

	private TestDictionary() {

	

}

	private IDictionary d;
	private IDictionaryFactory df;
	private Integer key1;
	private Integer key2;
	private Integer key3;
	private String value1;
	private String value2;
	private String value3;

	private void run() {

		System.out.println();	System.out.println();
		System.out.println("CREATING OBJECTS FOR EXERCISING A DICTIONARY"); System.out.println(); System.out.println();
		System.out.println("Creating ...");

		System.out.println("... a dictionary factory");
		df = new DictionaryFactory();

		System.out.println("... a dictionary");
		d = df.newObjectSatisfyingIDictionary();

		System.out.println("... some keys (10, 20, 30)");
		key1 = new Integer(10);
		key2 = new Integer(20);
		key3 = new Integer(30);

		System.out.println("... and some values (pineapple, peach, strawberry)");
		value1 = new String("pineapple");
		value2 = new String("peach");
		value3 = new String("strawberry");

		System.out.println("Done.");

		System.out.println();	System.out.println();
		System.out.println("EXERCISING THE DICTIONARY.");	System.out.println();	System.out.println();
		System.out.println("Each line of test output shows:");	System.out.println();
		System.out.println("    size / isEmpty / (key1,value) (key2,value) (key3,value)");	System.out.println();			System.out.println("('-' means no value for this key)");	System.out.println();	System.out.println();


		System.out.print("Initially dictionary is empty: ");
		display(d);
		System.out.println();

		System.out.print("Put key1 and value1: ");
		d.put(key1, value1);
		display(d);
		System.out.println();

		System.out.print("Put key2 and value2: ");
		d.put(key2, value2);
		display(d);
		System.out.println();

		System.out.print("Remove key1: ");
		d.remove(key1);
		display(d);
		System.out.println();

		System.out.print("Remove key2: ");
		d.remove(key2);
		display(d);
		System.out.println();

		System.out.print("Put key3 and value: ");
		d.put(key3, value3);
		display(d);
		System.out.println();

		System.out.print("Put key2 and value: ");
		d.put(key2, value2);
		display(d);
		System.out.println();

		System.out.print("Remove all keys: ");
		d.remove(key2);
		d.remove(key3);
		display(d);
		System.out.println();

		System.out.print("Put key3 then key1 then key2, with their values: ");
		d.put(key3, value3);
		display(d);
		d.put(key1, value1);
		display(d);
		d.put(key2, value2);
		display(d);
		System.out.println();
	

}

	private void display(IDictionary d) {

		System.out.println();
		System.out.print("    ");

		System.out.print(d.size());
		System.out.print(" / ");
		System.out.print(d.isEmpty());
		System.out.print(" / ");

		System.out.print("(" + key1 + ", ");	
		if (d.has(key1)){
			System.out.print(d.valueFor(key1));
		} else {
			System.out.print("-");
		}
		System.out.print(") ");

		System.out.print("(" + key2 + ", ");
		if (d.has(key2)){
			System.out.print(d.valueFor(key2));
		} else {
			System.out.print("-");
		}
		System.out.print(") ");

		System.out.print("(" + key3 + ", ");
		if (d.has(key3)){
			System.out.print(d.valueFor(key3));
		} else {
			System.out.print("-");
		}		
		System.out.print(")");
		System.out.println();
	

}
}
