@ECHO OFF
REM EXAMPLE of how to configure and use iContract on a DOS shell.
REM     Tested under Win2000, 
REM     jdk1.3.1_01 javac and VisualCafe sj
REM
REM produces instrumented files and .class code under %BASE%\instr
REM
REM run non-instrumented: java -cp %BASE%\src Main
REM run instrumented:     java -cp %BASE%\instr Main
REM
REM --------------------------------------------------------
REM --------------------------------------------------------
REM INSTALLATION: Please update to where you stored the 
REM   - iContract jar file
REM   - JDK
REM in the variables: ICONTRACT and JDK below
REM --------------------------------------------------------
REM --------------------------------------------------------
REM
REM assumes that cd is %BASE% (can be . or an absolute path)
REM assumes that src files are under %BASE%\src
REM assumes that the iContract jar file is at %ICONTRACT%
REM assumes that java and javac are on the PATH
REM 
SET ICONTRACT=C:\iContract\iContract-jdk1_2.jar
SET JDKBASE=C:\jdk1.3
SET JAVAC=javac
REM
REM --------------------------------------------------------
REM Should not require adaption. You may want to change 
REM %BASE% to the root of your project directory tree.
REM --------------------------------------------------------
SET BASE=.
SET SRC=%BASE%\src
SET CONTRACT_DB=%BASE%\.icontract-internal
SET INSTR=%BASE%\instr
REM
SET JDKTOOLS=%JDKBASE%\lib\tools.jar
SET JDK=%JDKBASE%\jre\lib\rt.jar

java -cp %ICONTRACT%;%SRC%;%CONTRACT_DB%;%INSTR%;%JDKTOOLS% com.reliablesystems.iContract.Tool -Z -a -v -minv,pre,post -b"%JAVAC% -classpath %ICONTRACT%;%SRC%;%JDK%" -c"%JAVAC% -classpath %ICONTRACT%;%INSTR%;%JDK%" -n"%JAVAC% -classpath %ICONTRACT%;%CONTRACT_DB%;%INSTR%;%JDK%" -o%INSTR%\@p\@f.@e -k%CONTRACT_DB%\@p %SRC%\*.java

java -cp %BASE%\src TestDictionary